
LootFilterVars = {
};

 
LootFilter = {
	VERSION = "1.7",
	LOOT_TIMEOUT = 30,
	LOOT_PARSE_DELAY = 1,
	LOOT_MAXTIME = 0,
	SCHEDULE_INTERVAL = 1;
	REALMPLAYER= "",
	NUMLINES = 10,

	qualities= {
		["QUGrey"]= 0,
		["QUWhite"]= 1,
		["QUGreen"]= 2,
		["QUBlue"]= 3,
		["QUPurple"]= 4,
		["QUOrange"]= 5,
		["QURed"]= 6,
		["QUQuest"]= -1 
	},
	radioButtonsText= {
		["QUGrey"]= "Poor (Grey)",
		["QUWhite"]= "Common (White)",
		["QUGreen"]= "Uncommon (Green)",
		["QUBlue"]= "Rare (Blue)",
		["QUPurple"]= "Epic (Purple)",
		["QUOrange"]= "Legendary (Orange)",
		["QURed"]= "Artifact (Red)",
		["QUQuest"]= "Quest",
		["TYCloth"]= "Cloth",
		["TYIdols"]= "Idols",
		["TYLeather"]= "Leather",
		["TYLibrams"]= "Librams",
		["TYMail"]= "Mail",
		["TYMiscellaneous"]= "Miscellaneous",
		["TYShields"]= "Shields",
		["TYTotems"]= "Totems",
		["TYPlate"]= "Plate",
		["TYConsumable"]= "Consumable",
		["TYBag"]= "Bag",
		["TYEnchantingBag"]= "Enchanting Bag",
		["TYEngineeringBag"]= "Engineering Bag",
		["TYHerbBag"]= "Herb Bag",
		["TYSoulBag"]= "Soul Bag",
		["TYKey"]= "Key",
		["TYJunk"]= "Junk",
		["TYReagent"]= "Reagent",
		["TYAlchemy"]= "Alchemy",
		["TYBlacksmithing"]= "Blacksmithing",
		["TYBook"]= "Book",
		["TYCooking"]= "Cooking",
		["TYEnchanting"]= "Enchanting",
		["TYEngineering"]= "Engineering",
		["TYFirstAid"]= "First Aid",
		["TYLeatherworking"]= "Leatherworking",
		["TYTailoring"]= "Tailoring",
		["TYArrow"]= "Arrow",
		["TYBullet"]= "Bullet",
		["TYQuest"]= "Quest",
		["TYAmmoPouch"]= "Ammo Pouch",
		["TYQuiver"]= "Quiver",
		["TYDevices"]= "Devices",
		["TYExplosives"]= "Explosives",
		["TYParts"]= "Parts",
		["TYTradeGoods"]= "Trade Goods",
		["TYBows"]= "Bows",
		["TYCrossbows"]= "Crossbows",
		["TYDaggers"]= "Daggers",
		["TYGuns"]= "Guns",
		["TYFishingPole"]= "Fishing Pole",
		["TYFistWeapons"]= "Fist Weapons",
		["TYOneHandedAxes"]= "One-Handed Axes",
		["TYOneHandedMaces"]= "One-Handed Maces",
		["TYOneHandedSwords"]= "One-Handed Swords",
		["TYPolearms"]= "Polearms",
		["TYStaves"]= "Staves",
		["TYThrown"]= "Thrown",
		["TYTwoHandedAxes"]= "Two-Handed Axes",
		["TYTwoHandedMaces"]= "Two-Handed Maces",
		["TYTwoHandedSwords"]= "Two-Handed Swords",
		["OPEnable"]= "Enable Loot Filter",
		["OPCaching"]= "Enable Loot Caching",
		["OPTooltips"]= "Show tooltips",
		["OPNotifyDelete"]= "Notify on delete",
		["OPNotifyKeep"]= "Notify on keep",
		["OPNotifyNoMatch"]= "Notify on no match",
		["OPNotifyOpen"]= "Notify on open",
		["OPValKeep"]= "Keep items worth more then",
		["OPValDelete"]= "Delete items worth less then",
		["OPNoValue"]= "Keep items with no (known) value",
		["TYWands"]= "Wands"
	},
	timerArr= {},
	hooked= false,
	lastUpdate= 0,
	itemValueSupport= 0,
	hasFocus= 0;
	spellCast = false;
	cleanList = {};
};


LootFilter.print= function (value)
	if (value == nil) then
		value= "";
	end;
	DEFAULT_CHAT_FRAME:AddMessage("Loot Filter - "..value, 1.0, 1.0, 1.0);
end;
LootFilter.debug= function (value)
	if (value == nil) then
		value= "";
	end;
	DEFAULT_CHAT_FRAME:AddMessage("Loot Filter - DEBUG: "..value, 1.0, 1.0, 1.0);
end;

LootFilter.report= function (value)
	if (LootFilterVars[LootFilter.REALMPLAYER].report) then
		LootFilter.print(value);
	end;
end;

LootFilter.schedule= function (delay, func, arg)
	table.insert(LootFilter.timerArr, {time=time()+delay, func=func, args=arg});
	if (not LootFilter.hooked) then
		LootFilter.hook();
	end;
end;

-- borrowed from Informant (local function)
LootFilter.split= function (str, at)
	if (not (type(str) == "string")) then
		return
	end

	if (not str) then
		str = ""
	end

	if (not at) then
		return {str}
	else
		return {strsplit(at, str)};
	end
end


LootFilter.WorldFrame_OnUpdate= function ()
	Original_WorldFrame_OnUpdate();
	local curtime= time();
	if (LootFilter.lastUpdate < curtime) then
		if (table.getn(LootFilter.timerArr) == 0) then
			LootFilter.unhook();
			return;
		end;
		for i=1, table.getn(LootFilter.timerArr), 1 do
			if (LootFilter.timerArr[i].time <= curtime) then
				func= LootFilter.timerArr[i].func;
				args= LootFilter.timerArr[i].args;
				table.remove(LootFilter.timerArr,i);
				func(args);
				return;
			end;
		end;
		LootFilter.lastUpdate= curtime+1;
	end;
end;

LootFilter.hook= function ()
	Original_WorldFrame_OnUpdate= WorldFrame_OnUpdate;
	WorldFrame_OnUpdate= LootFilter.WorldFrame_OnUpdate;
	LootFilter.hooked= true;
end;

LootFilter.unhook= function ()
	WorldFrame_OnUpdate= Original_WorldFrame_OnUpdate;
	LootFilter.hooked= false;
end;

LootFilter.setTitle= function()
	LootFilterFrameTitleText:SetText("Loot Filter v"..LootFilter.VERSION);
end;

LootFilter.stripComment= function(searchName)
	local commentPos = string.find(searchName, ";", 1, true);
	if (commentPos ~= nil) and (commentPos > 0) then -- comment found
		searchName= string.sub(searchName, 0, commentPos-1);
		searchName= strtrim(searchName);
	end;
	return searchName;
end;

LootFilter.matches= function(itemName, searchName)
	if (itemName == nil) or (searchName == nil) then
		return false;
	end;
	searchName= LootFilter.stripComment(searchName);
	if (string.find(searchName, "#", 1, true) == 1) then
		if (string.find(string.lower(itemName), string.lower(string.sub(searchName, 2)))) then
			return true;
		end;
	elseif (string.lower(itemName) == string.lower(searchName)) then
		return true;
	end;
	return false;
end;

LootFilter.matchInformantType = function (value, itemid)
	itemData = Informant.GetItem(itemid);
	if (itemData ~= nil) and (itemData['usedby'] ~= nil) then
		usedby = itemData['usedby'];
		if (usedby ~= nil) then
			local usedList = LootFilter.split(usedby, ",")
			if (usedList) then
				for pos, userSkill in pairs(usedList) do
					if (((value == "TYAlchemy") and (userSkill == 171)) or
						((value == "TYBlacksmithing") and (userSkill == 164)) or
						((value == "TYCooking") and (userSkill == 185)) or
						((value == "TYEnchanting") and (userSkill == 333)) or
						((value == "TYEngineering") and (userSkill == 202)) or
						((value == "TYFirstAid") and (userSkill == 129)) or
						((value == "TYLeatherworking") and (userSkill == 165)) or
						((value == "TYTailoring") and (userSkill == 197))) then
						return true;
					end;
				end
			end
		end;
	end;
	return false;
end;

LootFilter.openIfContainer= function (j, i, itemlink)
	local itemName = LootFilter.getItemName(itemlink);
	for key,value in pairs(LootFilterVars[LootFilter.REALMPLAYER].openList) do
		if (LootFilter.matches(itemName, value)) then
			if (not LootFilter.spellCast) then	
				if (LootFilterVars[LootFilter.REALMPLAYER].notifyopen) then
					LootFilter.print("trying to open "..itemlink.." : name matched ("..value..")");
				end;
				UseContainerItem(j, i);
				return true;
			end;
			LootFilter.LOOT_MAXTIME = time() + LootFilter.LOOT_TIMEOUT;
			return true;
		end;
	end;
	return false;
end;

LootFilter.getItemValueInformant= function(itemid)
	itemValue = -1;
	itemData = Informant.GetItem(itemid);
	if (itemData ~= nil) and (itemData['sell'] ~= nil) then
		itemValue = tonumber(itemData['sell']);
	end;
	return itemValue;
end;

LootFilter.getItemValueItemSync= function(itemid)
	itemValue = -1;
	if (ItemSync.db.account[ItemSync.realm]["items"][itemid] ~= nil) then
		string = ItemSync.db.account[ItemSync.realm]["items"][itemid];
		split = LootFilter.split(string, "");
		itemValue = tonumber(split[2]);
	end;
	return itemValue;
end;

LootFilter.getValueOfItem = function(itemid)
	local itemValue = -1;
	if (LootFilter.itemValueSupport == 1) then -- Informant
		itemValue= LootFilter.getItemValueInformant(itemid);
	elseif (LootFilter.itemValueSupport == 2) then -- ItemSync
		itemValue= LootFilter.getItemValueItemSync(itemid);
	end;
	return itemValue;
end;

LootFilter.getItemId = function(itemLink)
	return tonumber(string.match(itemLink, ":(%d+)"));
end;
LootFilter.getItemName = function(itemLink)
	return string.match(itemLink, "%[(.*)%]");
end;

LootFilter.deleteItemFromInventory= function (searchItem, search, deleteItem)
	local searchName= LootFilter.getItemName(searchItem);
	for j=0 , 4 , 1 do
		x = GetContainerNumSlots(j);
		for i=0 , x , 1 do
			local itemlink= GetContainerItemLink(j,i);
			if (itemlink ~= nil) then
				local itemName = LootFilter.getItemName(itemlink);
				local itemid = LootFilter.getItemId(itemlink);
				if (itemid >= 1) then
					if LootFilter.matches(itemName, searchName, "") then
						local reason = "";
						if (deleteItem == "") then
							if (LootFilter.openIfContainer(j, i, itemlink)) and (not search) then
								return false;
							end;
							local _, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount = GetItemInfo(itemid)
							local keep = false;
							for key,value in pairs(LootFilterVars[LootFilter.REALMPLAYER].keepList) do
								if (string.match(key, "^QU")) then -- quality entry
									if (itemRarity == value) then
										reason = "quality matched ("..value..")";
										keep = true;
									elseif (value == -1) then
										if (string.lower(itemType) == "quest") then
											reason= "quest item";
											keep = true;
										end;
									end;
								elseif (string.match(key, "^TY")) then -- type entry
									if (itemSubType == value) then
										reason= "type matched ("..value..")";
										keep = true;
									elseif (LootFilter.itemValueSupport == 1) then
										if (LootFilter.matchInformantType(key, itemid)) then
											reason= "Informant type matched ("..value..")";
											keep = true;
										end;
									end;
								elseif (string.match(key, "^VA")) then -- value entry
									if (LootFilter.itemValueSupport ~= 0) and (LootFilterVars[LootFilter.REALMPLAYER].keepList["VAOn"]) then
										local itemValue = LootFilter.getValueOfItem(itemid);

										if (LootFilterVars[LootFilter.REALMPLAYER].keepList["VANoValue"]) and ((itemValue == nil) or (itemValue <= 0)) then
											reason= "item has no known value";
											keep= true;
										elseif (itemValue ~= nil) and (itemValue > 0) then
											itemStackCount = tonumber(itemStackCount);
											if (itemStackCount ~= nil) and (itemStackCount > 1) then
												itemValue= itemValue * itemStackCount;
											end;
											itemValue= tonumber(itemValue / 10000);
											if (tonumber(itemValue) > tonumber(LootFilterVars[LootFilter.REALMPLAYER].keepList["VAValue"])) then
												reason= "value is high enough ("..tonumber(itemValue)..")";
												keep = true;
											end;
										end;	
									end;
								elseif (key == "names") then
									for _, name in pairs(value) do
										if (LootFilter.matches(searchName, name)) then
											reason= "name matched ("..name..")";
											keep = true;
											break;
										end;
									end;
								end;
								if (keep) then
									if (not search) then
										if (LootFilterVars[LootFilter.REALMPLAYER].notifykeep) then
											LootFilter.print(itemlink.." was kept: "..reason);
										end;
										table.remove(LootFilterVars[LootFilter.REALMPLAYER].itemStack, 1);
										return true;
									else
										return false;
									end;
								end;
							end;
							
							if (LootFilterVars[LootFilter.REALMPLAYER].caching) and (not search) then
								table.remove(LootFilterVars[LootFilter.REALMPLAYER].itemStack, 1);
								return;
							end;

							local delete = false;
							for key,value in pairs(LootFilterVars[LootFilter.REALMPLAYER].deleteList) do
								if (string.match(key, "^QU")) then -- quality entry
									if (itemRarity == value) then
										reason= "quality matched ("..value..")";
										delete = true;
									elseif (value == -1) then
										if (string.lower(itemType) == "quest") then
											reason= "quest item";
											delete = true;
										end;
									end;
								elseif (string.match(key, "^TY")) then -- type entry
									if (itemSubType == value) then
										reason= "type matched ("..value..")";
										delete = true;
									end;
								elseif (string.match(key, "^VA")) then -- value entry
									if (LootFilter.itemValueSupport ~= 0) and (LootFilterVars[LootFilter.REALMPLAYER].deleteList["VAOn"]) then
										local itemValue = LootFilter.getValueOfItem(itemid);

										if (LootFilterVars[LootFilter.REALMPLAYER].keepList["VANoValue"]) and ((itemValue == nil) or (itemValue <= 0)) then
											reason= "item has no known value";
											break;
										elseif (itemValue ~= nil) and (itemValue > 0) then
											itemStackCount = tonumber(itemStackCount);
											if (itemStackCount ~= nil) and (itemStackCount > 1) then
												itemValue= itemValue * itemStackCount;
											end;
											itemValue= tonumber(itemValue / 10000);
											if (tonumber(itemValue) < tonumber(LootFilterVars[LootFilter.REALMPLAYER].deleteList["VAValue"])) then
												reason= "value not high enough ("..tonumber(itemValue)..")";
												delete = true;
											end;
										end;	
									end;
								elseif (key == "names") then
									for _, name in pairs(value) do
										if (LootFilter.matches(searchName, name)) then
											reason= "name matched ("..name..")";
											delete = true;
											break;
										end;
									end;
								end;
								if (delete) then
									break;
								end;
							end;

							if (search) then
								return delete;
							end;

							if (not delete) then
								if (reason == "") then
									if (LootFilterVars[LootFilter.REALMPLAYER].notifynomatch) then
										LootFilter.print(itemlink.." was kept: no matching criteria found");
									end;
								else
									if (LootFilterVars[LootFilter.REALMPLAYER].notifykeep) then
										LootFilter.print(itemlink.." was kept: "..reason);
									end;
								end;
								table.remove(LootFilterVars[LootFilter.REALMPLAYER].itemStack, 1);
								return true;
							end;
						else
							reason = deleteItem;
						end;

						if (not search) then
							if (deleteItem == "cleaning") and (LootFilterButtonDeleteItems:GetText() == "Sell items") then
								UseContainerItem(j,i);
								table.remove(LootFilterVars[LootFilter.REALMPLAYER].itemStack, 1);
								if (LootFilterVars[LootFilter.REALMPLAYER].notifydelete) then
									LootFilter.print(itemlink.." was sold: "..reason);
									if (LootFilter.questUpdateToggle == 1) then
										LootFilter.lastDeleted = itemName; 
									end;
								end;
								return true;
							else
								PickupContainerItem(j, i);
								if (CursorHasItem()) then
									DeleteCursorItem();
									table.remove(LootFilterVars[LootFilter.REALMPLAYER].itemStack, 1);
									if (LootFilterVars[LootFilter.REALMPLAYER].notifydelete) then
										LootFilter.print(itemlink.." was deleted: "..reason);
										if (LootFilter.questUpdateToggle == 1) then
											LootFilter.lastDeleted = itemName; 
										end;
									end;
									return true;
								else
									return false;
								end;
							end;
						end;
					end;
				end;
			end;
		end
	end;
	return false;
end

LootFilter.findItems= function ()
	numitems= table.getn(LootFilterVars[LootFilter.REALMPLAYER].itemStack);
	if (numitems == 0) then
		return;
	end;

	if (time() > LootFilter.LOOT_MAXTIME) then
		LootFilterVars[LootFilter.REALMPLAYER].itemStack = {};
		return;
	end;

	if (not LootFilter.deleteItemFromInventory(LootFilterVars[LootFilter.REALMPLAYER].itemStack[1], false, "")) then
		if (table.getn(LootFilterVars[LootFilter.REALMPLAYER].itemStack) > 1) then
			table.insert(LootFilterVars[LootFilter.REALMPLAYER].itemStack, LootFilterVars[LootFilter.REALMPLAYER].itemStack[1]);
			table.remove(LootFilterVars[LootFilter.REALMPLAYER].itemStack, 1);
		end;
	end;
	LootFilter.schedule(LootFilter.SCHEDULE_INTERVAL, LootFilter.findItems);
end


LootFilter.getNames= function ()
	local result= "";
	table.sort(LootFilterVars[LootFilter.REALMPLAYER].keepList["names"]);
	for key, value in ipairs(LootFilterVars[LootFilter.REALMPLAYER].keepList["names"]) do
		result= result..value.."\n";	
	end;
	LootFilterEditBox1:SetText(result);
end;

LootFilter.getNamesDelete= function ()
	local result= "";
	table.sort(LootFilterVars[LootFilter.REALMPLAYER].deleteList["names"]);
	for key, value in ipairs(LootFilterVars[LootFilter.REALMPLAYER].deleteList["names"]) do
		result= result..value.."\n";
	end;
	LootFilterEditBox2:SetText(result);
end;
LootFilter.getOpenNames= function ()
	local result= "";
	table.sort(LootFilterVars[LootFilter.REALMPLAYER].openList);
	for key, value in ipairs(LootFilterVars[LootFilter.REALMPLAYER].openList) do
		result= result..value.."\n";	
	end;
	LootFilterEditBoxOpen:SetText(result);
end;

LootFilter.setNames= function ()
	LootFilterVars[LootFilter.REALMPLAYER].keepList["names"]= {};
	local result= LootFilterEditBox1:GetText().."\n";
	if (result ~= nil) then
		for w in string.gmatch(result, "[^\n]+\n") do
			w = string.gsub(w, "\n", "");
			table.insert(LootFilterVars[LootFilter.REALMPLAYER].keepList["names"], w);
		end;
	end;
end;
LootFilter.setNamesDelete= function ()
	LootFilterVars[LootFilter.REALMPLAYER].deleteList["names"]= {};
	local result= LootFilterEditBox2:GetText().."\n";
	if (result ~= nil) then
		for w in string.gmatch(result, "[^\n]+\n") do
			w = string.gsub(w, "\n", "");
			table.insert(LootFilterVars[LootFilter.REALMPLAYER].deleteList["names"], w);
		end;
	end;
end;
LootFilter.setOpenNames= function()
	LootFilterVars[LootFilter.REALMPLAYER].openList= {};
	local result= LootFilterEditBoxOpen:GetText().."\n";
	if (result ~= nil) then
		for w in string.gmatch(result, "[^\n]+\n") do
			w = string.gsub(w, "\n", "");
			table.insert(LootFilterVars[LootFilter.REALMPLAYER].openList, w);
		end;
	end;
end;


LootFilter.setItemValue= function ()
	local value= tonumber(LootFilterEditBox3:GetText());
	if (value == nil) or (value == "") then
		value= "0";
	end;
	LootFilterVars[LootFilter.REALMPLAYER].deleteList["VAValue"]= value;

	local value= tonumber(LootFilterEditBox4:GetText());
	if (value == nil) or (value == "") then
		value= "0";
	end;
	LootFilterVars[LootFilter.REALMPLAYER].keepList["VAValue"]= value;

	local value= tonumber(LootFilterEditBox5:GetText());
	if (value == nil) or (value == "") then
		value= "0";
	end;
	LootFilterVars[LootFilter.REALMPLAYER].freebagslots= value;
end;

LootFilter.getItemValue= function ()
	local value= "";
	if (LootFilterVars[LootFilter.REALMPLAYER].deleteList["VAValue"] ~= nil) and (LootFilterVars[LootFilter.REALMPLAYER].deleteList["VAValue"] ~= "") then
		value= LootFilterVars[LootFilter.REALMPLAYER].deleteList["VAValue"];
	else
		value= "0";
	end;
	LootFilterEditBox3:SetText(value);
	local value= "";
	if (LootFilterVars[LootFilter.REALMPLAYER].keepList["VAValue"] ~= nil) and (LootFilterVars[LootFilter.REALMPLAYER].keepList["VAValue"] ~= "") then
		value= LootFilterVars[LootFilter.REALMPLAYER].keepList["VAValue"];
	else
		value= "0";
	end;
	LootFilterEditBox4:SetText(value);
	local value= "";
	if (LootFilterVars[LootFilter.REALMPLAYER].freebagslots ~= nil) and (LootFilterVars[LootFilter.REALMPLAYER].freebagslots ~= "") then
		value= LootFilterVars[LootFilter.REALMPLAYER].freebagslots;
	else
		value= "0";
	end;
	LootFilterEditBox5:SetText(value);
end;


LootFilter.command= function (cmd)
	args= {};
	i= 1;
	for w in string.gmatch(cmd, "%w+") do
		args[i]= w;
		i= i + 1;
	end;

	if (table.getn(args) == 0) then
		if (not LootFilterOptions:IsShown()) then
			LootFilterOptions:Show();
		else
			LootFilterOptions:Hide();
		end;
		return;
	end;
end;

LootFilter.updateFocus= function (num , value)
	if (value) then
		this:SetFocus();
		LootFilter.hasFocus= num;
	else
		this:ClearFocus();
		LootFilter.hasFocus= 0;
	end;
end;

LootFilter.findItemWithLock= function ()
	for j=0 , 4 , 1 do
		x = GetContainerNumSlots(j);
		for i=0 , x , 1 do
			local _, _, locked = GetContainerItemInfo(j,i);
			if (locked) then
				local itemlink= GetContainerItemLink(j,i);
				if (itemlink ~= nil) then
					local itemName = GetItemInfo(itemlink);
					return itemName;
				end;
			end;
		end;
	end;
	return "";
end;

LootFilter.OnEvent= function ()

	if (event == "UNIT_SPELLCAST_START") then
		LootFilter.spellCast = true;
	end;
	if (event == "UNIT_SPELLCAST_STOP") then
		LootFilter.spellCast = false;
	end;

	if (event == "UI_INFO_MESSAGE") then
		if (LootFilterVars[LootFilter.REALMPLAYER].deleteList["QUQuest"] == nil) then
			if (string.find(arg1, "slain: ") ~= nil) and (string.find(arg1, "slain: ") > 0) then
				return;
			end;
			local itemName = gsub(arg1,"(.*): %s*([-%d]+)%s*/%s*([-%d]+)%s*$","%1",1);
			if (itemName ~= arg1) then
				for index,name in pairs(LootFilterVars[LootFilter.REALMPLAYER].keepList["names"]) do
					if (LootFilter.matches(itemName, name)) then
						return;
					end;
				end;

				for index, itemLink in pairs(LootFilterVars[LootFilter.REALMPLAYER].itemStack) do
					local name = string.match(itemLink, "%[(.*)%]");
					if (string.lower(name) == string.lower(itemName)) then
						table.remove(LootFilterVars[LootFilter.REALMPLAYER].itemStack, index);
						if (LootFilterVars[LootFilter.REALMPLAYER].notifykeep) then
							LootFilter.print(itemLink.." was kept: quest item");
						end;
						local _, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount = GetItemInfo(itemLink);
						if (string.lower(itemType) ~= "quest") and (string.lower(itemSubType) ~= "quest") then
							table.insert(LootFilterVars[LootFilter.REALMPLAYER].keepList["names"], itemName.."  ; Added because of quest");
						end;
						return;
					end;
				end;


				-- ***** should not ever get here if an item was looted, but keeping it in just in case i have to put it back *****
				-- table.insert(LootFilterVars[LootFilter.REALMPLAYER].keepList["names"], itemName.."  ; Added because of quest");
				-- if (LootFilterVars[LootFilter.REALMPLAYER].notifykeep) then
				-- 	LootFilter.print(itemName.." was kept: quest item");
				-- end;
			end;
		end;
	end;
	

	if (event == "LOOT_OPENED") and (LootFilterVars[LootFilter.REALMPLAYER].enabled) then
		numitems= GetNumLootItems();
		for i=1, numitems, 1 do
			if (not LootSlotIsCoin(i)) then
				icon, name, quantity, quality= GetLootSlotInfo(i);
				if (icon ~= nil) then
					table.insert(LootFilterVars[LootFilter.REALMPLAYER].itemStack, GetLootSlotLink(i));
				end;
			end;
		end;
	end;

	if (event == "LOOT_CLOSED") then
		LootFilter.LOOT_MAXTIME = time() + LootFilter.LOOT_TIMEOUT;
		if (table.getn(LootFilter.timerArr) == 0) then
			if (LootFilterVars[LootFilter.REALMPLAYER].caching) then
				LootFilterVars[LootFilter.REALMPLAYER].itemStack = {};
				LootFilter.schedule(LootFilter.LOOT_PARSE_DELAY, LootFilter.scanBags, false);
			else
				LootFilter.schedule(LootFilter.LOOT_PARSE_DELAY, LootFilter.findItems);
			end;
		end;
	end;

	if (event == "ITEM_LOCK_CHANGED") then
		if (LootFilter.hasFocus > 0) then
			itemName= LootFilter.findItemWithLock();
			if (itemName ~= nil) and (itemName ~= "") then
				if (LootFilter.hasFocus == 1) then
					LootFilterEditBox1:SetText(LootFilterEditBox1:GetText()..itemName.."\n");
				elseif (LootFilter.hasFocus == 2) then
					LootFilterEditBox2:SetText(LootFilterEditBox2:GetText()..itemName.."\n");
				end;
			end;
		end;
	end;

	if (event == "MERCHANT_CLOSED") then
		LootFilterButtonDeleteItems:SetText("Delete items");
	end;

	if (event == "MERCHANT_SHOW") then
		LootFilterButtonDeleteItems:SetText("Sell items");
	end;

	if (event == "ADDON_LOADED") then

		if (arg1 == "LootFilter") then
			LootFilter.REALMPLAYER= GetCVar("realmName")..UnitName("player");
			if (LootFilterVars[LootFilter.REALMPLAYER] == nil) then
				LootFilterVars[LootFilter.REALMPLAYER]= {};
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].openList == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].openList= {};
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].keepList == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].keepList= {};
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].keepList["names"] == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].keepList["names"] = {};
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].deleteList == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].deleteList= {};
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].deleteList["names"] == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].deleteList["names"] = {};
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].itemStack == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].itemStack= {};
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].enabled == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].enabled= true;
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].tooltips == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].tooltips= true;
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].notifydelete == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].notifydelete= true;
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].notifykeep == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].notifykeep= true;
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].notifynomatch == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].notifynomatch= true;
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].notifyopen == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].notifyopen= true;
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].caching == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].caching= false;
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].freebagslots == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].freebagslots= 5;
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].notifyopen == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].notifyopen= true;
			end;
			if (LootFilterVars[LootFilter.REALMPLAYER].keepList["VANoValue"] == nil) then
				LootFilterVars[LootFilter.REALMPLAYER].keepList["VANoValue"]= true;
			end;
		end;
		LootFilter.checkDepencies();
		LootFilterButtonGeneral:LockHighlight();
		LootFilter.getNames();
		LootFilter.getNamesDelete();
		LootFilter.getOpenNames();
		LootFilter.getItemValue();
	end;
end;

LootFilter.checkDepencies= function ()
	if (IsAddOnLoaded("Informant")) then
		LootFilter.itemValueSupport= 1; -- Informant
	elseif (IsAddOnLoaded("ItemSync")) and (LootFilter.itemValueSupport == 0) then -- Informant has priority
	 	LootFilter.itemValueSupport= 2; -- ItemSync
	end;
	if (LootFilter.itemValueSupport ~= 0) then
		LootFilterOPCaching:Show();
		if (LootFilterVars[LootFilter.REALMPLAYER].caching) then
			LootFilterEditBox5:Show();
			LootFilterTextBackground5:Show();
			LootFilterFreeSlotsText:Show();
			LootFilterOPNoValue:Show();
		else
			LootFilterOPValKeep:Show();
			LootFilterOPValDelete:Show();
			LootFilterOPNoValue:Show();
			LootFilterEditBox3:Show();
			LootFilterEditBox4:Show();
			LootFilterTextBackground3:Show();
			LootFilterTextBackground4:Show();
		end;
		LootFilterNeedAddon:Hide();
	else
		LootFilterVars[LootFilter.REALMPLAYER].caching = false;
	end;
end;

LootFilter.OnLoad= function ()

	SLASH_LOOTFILTER1= "/lootfilter";
	SLASH_LOOTFILTER2= "/lf";
	SLASH_LOOTFILTER3= "/lfr";
	SlashCmdList["LOOTFILTER"] = LootFilter.command;

	this:RegisterEvent("LOOT_OPENED");
	this:RegisterEvent("LOOT_CLOSED");
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("ITEM_LOCK_CHANGED");
	this:RegisterEvent("UI_INFO_MESSAGE");
	this:RegisterEvent("UNIT_SPELLCAST_START");
	this:RegisterEvent("UNIT_SPELLCAST_STOP");
	this:RegisterEvent("MERCHANT_CLOSED");
	this:RegisterEvent("MERCHANT_SHOW");
end;


LootFilter.selectButton = function (button, frame)
	LootFilter.setNames();
	LootFilter.setNamesDelete();
	LootFilter.setOpenNames();

	LootFilterButtonGeneral:UnlockHighlight();
	LootFilterButtonQuality:UnlockHighlight();
	LootFilterButtonType:UnlockHighlight();
	LootFilterButtonName:UnlockHighlight();
	LootFilterButtonValue:UnlockHighlight();
	LootFilterButtonClean:UnlockHighlight();
	LootFilterButtonOpen:UnlockHighlight();
	LootFilterButtonCopy:UnlockHighlight();

	LootFilterFrameGeneral:Hide();
	LootFilterFrameQuality:Hide();
	LootFilterFrameType:Hide();
	LootFilterFrameName:Hide();
	LootFilterFrameValue:Hide();
	LootFilterFrameClean:Hide();
	LootFilterFrameOpen:Hide();
	LootFilterFrameCopy:Hide();

	button:LockHighlight();
	frame:Show();
end;

LootFilter.trim = function(name)
	return string.gsub(name, "LootFilter", "");	
end;

LootFilter.setRadioButtonsValue = function (button)
	local name = LootFilter.trim(button:GetParent():GetName());
	if (LootFilterVars[LootFilter.REALMPLAYER].keepList[name] ~= nil) then
		LootFilterVars[LootFilter.REALMPLAYER].keepList[name]= nil;
	end;
	if (LootFilterVars[LootFilter.REALMPLAYER].deleteList[name] ~= nil) then
		LootFilterVars[LootFilter.REALMPLAYER].deleteList[name]= nil;
	end;
	local children = { this:GetParent():GetChildren() };
	local i = 0;
	for _, child in ipairs(children) do
		if (child ~= button) then
			child:SetChecked(false);
		else
			button:SetChecked(true);
			if (i == 1) then
				if (string.match(name, "^QU")) then
					LootFilterVars[LootFilter.REALMPLAYER].keepList[name]= LootFilter.qualities[name];
				elseif (string.match(name, "^TY")) then
					LootFilterVars[LootFilter.REALMPLAYER].keepList[name]= LootFilter.radioButtonsText[name];
				else
					LootFilterVars[LootFilter.REALMPLAYER].keepList[name]= true;
				end;
			elseif (i == 2) then
				if (string.match(name, "^QU")) then
					LootFilterVars[LootFilter.REALMPLAYER].deleteList[name]= LootFilter.qualities[name];
				elseif (string.match(name, "^TY")) then
					LootFilterVars[LootFilter.REALMPLAYER].deleteList[name]= LootFilter.radioButtonsText[name];
				else
					LootFilterVars[LootFilter.REALMPLAYER].deleteList[name]= true;
				end;
			end;
		end;
		i = i + 1;
	end;
end;

LootFilter.getRadioButtonsValue = function(button)
	local name = LootFilter.trim(button:GetName());
	local fontString = getglobal(button:GetName().."_Text");
	local radioButton = getglobal(button:GetName().."_Default");
	getglobal(button:GetName().."_Default"):SetChecked(false);
	getglobal(button:GetName().."_Keep"):SetChecked(false);
	getglobal(button:GetName().."_Delete"):SetChecked(false);
	fontString:SetText(LootFilter.radioButtonsText[name]);
	if (LootFilterVars[LootFilter.REALMPLAYER].keepList[name] ~= nil) then
		radioButton = getglobal(button:GetName().."_Keep");
	elseif (LootFilterVars[LootFilter.REALMPLAYER].deleteList[name] ~= nil) then
		radioButton = getglobal(button:GetName().."_Delete");
	end;
	radioButton:SetChecked(true);
end;

LootFilter.setRadioButtonValue = function (button)
	local name = LootFilter.trim(button:GetParent():GetName());
	local checked = false;
	if (button:GetChecked()) then
		checked = true;
	end;

	if (name == "OPEnable") then
		LootFilterVars[LootFilter.REALMPLAYER].enabled = checked;
	elseif (name == "OPCaching") then
		LootFilterVars[LootFilter.REALMPLAYER].caching = checked;
		if (checked) then
			LootFilterOPValKeep:Hide();
			LootFilterOPValDelete:Hide();
			LootFilterOPNoValue:Show();
			LootFilterEditBox3:Hide();
			LootFilterEditBox4:Hide();
			LootFilterEditBox5:Show();
			LootFilterTextBackground3:Hide();
			LootFilterTextBackground4:Hide();
			LootFilterTextBackground5:Show();
			LootFilterFreeSlotsText:Show();
		else
			LootFilterOPValKeep:Show();
			LootFilterOPValDelete:Show();
			LootFilterOPNoValue:Show();
			LootFilterEditBox3:Show();
			LootFilterEditBox4:Show();
			LootFilterEditBox5:Hide();
			LootFilterTextBackground3:Show();
			LootFilterTextBackground4:Show();
			LootFilterTextBackground5:Hide();
			LootFilterFreeSlotsText:Hide();
		end;

	elseif (name == "OPTooltips") then
		LootFilterVars[LootFilter.REALMPLAYER].tooltips = checked;
	elseif (name == "OPNotifyDelete") then
		LootFilterVars[LootFilter.REALMPLAYER].notifydelete = checked;
	elseif (name == "OPNotifyKeep") then
		LootFilterVars[LootFilter.REALMPLAYER].notifykeep = checked;
	elseif (name == "OPNotifyNoMatch") then
		LootFilterVars[LootFilter.REALMPLAYER].notifynomatch = checked;
	elseif (name == "OPNotifyOpen") then
		LootFilterVars[LootFilter.REALMPLAYER].notifyopen = checked;
	elseif (name == "OPValKeep") then
		LootFilterVars[LootFilter.REALMPLAYER].keepList["VAOn"] = checked;
	elseif (name == "OPValDelete") then
		LootFilterVars[LootFilter.REALMPLAYER].deleteList["VAOn"] = checked;
	elseif (name == "OPNoValue") then
		LootFilterVars[LootFilter.REALMPLAYER].keepList["VANoValue"] = checked;
	end;
end;

LootFilter.getRadioButtonValue = function (button)
	local name = LootFilter.trim(button:GetName());
	local fontString = getglobal(button:GetName().."_Text");
	local radioButton = getglobal(button:GetName().."_Button");
	fontString:SetText(LootFilter.radioButtonsText[name]);
	if (name == "OPEnable") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].enabled);
	elseif (name == "OPCaching") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].caching);
	elseif (name == "OPTooltips") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].tooltips);
	elseif (name == "OPNotifyDelete") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].notifydelete);
	elseif (name == "OPNotifyKeep") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].notifykeep);
	elseif (name == "OPNotifyOpen") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].notifyopen);
	elseif (name == "OPNotifyNoMatch") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].notifynomatch);
	elseif (name == "OPValKeep") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].keepList["VAOn"]);
	elseif (name == "OPValDelete") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].deleteList["VAOn"]);
	elseif (name == "OPNoValue") then
		radioButton:SetChecked(LootFilterVars[LootFilter.REALMPLAYER].keepList["VANoValue"]);
	end;
end;

LootFilter.showTooltip = function(area, text)
	if (LootFilterVars[LootFilter.REALMPLAYER].tooltips) then
		GameTooltip:SetOwner(area, "ANCHOR_RIGHT")
		GameTooltip:SetText(text, 1, 1, 1, 0.75, 1);
		GameTooltip:Show();
	end;
end;

LootFilter.copySettings = function()
	for key,value in pairs(LootFilterVars) do	
		if (string.upper(LootFilterEditBoxCopy1:GetText()..LootFilterEditBoxCopy2:GetText()) == string.upper(key)) then
			LootFilterVars[LootFilter.REALMPLAYER] = LootFilterVars[key];
			LootFilter.getNames();
			LootFilter.getNamesDelete();
			LootFilter.getOpenNames();
			LootFilter.getItemValue();
			LootFilterEditBoxTitleCopy4:SetText("Settings were copied succesfully.");
			LootFilterEditBoxCopy1:SetText("");
			LootFilterEditBoxCopy2:SetText("");
			return;
		end;
	end;
	LootFilterEditBoxTitleCopy4:SetText("The selected server and character combination does not exist or\ndoes not have any settings to copy.");
end;

LootFilter.initClean = function()
	LootFilterButtonDeleteItems:Enable();
	LootFilterButtonIWantTo:Disable();
	for line=1,19 do
		cleanLine = getglobal("cleanLine"..line);
		cleanLine:SetText("");
		cleanLine:Hide();
	end
end;

LootFilter.scanBags = function(display)
	function sortByValue(a, b)
		if ( not a ) then return true;	elseif ( not b ) then return false; end
		local _, _, _, _, _, _, _, aSC = GetItemInfo(a);
		local _, _, _, _, _, _, _, bSC = GetItemInfo(b);
		if ((LootFilter.getValueOfItem(LootFilter.getItemId(a))*aSC) > 
			(LootFilter.getValueOfItem(LootFilter.getItemId(b))*bSC)) then
			return false
		end;
		return true;
	end;

	-- A shameless copy from LootLink
	function sortByLink(e1, e2)
		if ( not e1 ) then return true;	elseif ( not e2 ) then return false; end
		local _,_,a,b,c = string.find(e1, "(%d+):(%d+):(%d+)");
		local _,_,d,e,f = string.find(e2, "(%d+):(%d+):(%d+)");

		if a ~= d then return tonumber(a) > tonumber(d); end
		if c ~= f then return tonumber(c) > tonumber(f); end
		if b ~= e then return tonumber(b) < tonumber(e); end
		return false;
	end;
	if (display) then
		LootFilterButtonDeleteItems:Disable();
		LootFilterButtonIWantTo:Disable();
	end;
	LootFilter.cleanList = {};
	local z = 1;
	local slots = 0;
	
	for j=0 , 4 , 1 do
		x = GetContainerNumSlots(j);
		for i=1 , x , 1 do
			local itemlink= GetContainerItemLink(j,i);
			if (itemlink ~= nil) then
				local itemName = LootFilter.getItemName(itemlink);
				local itemid = LootFilter.getItemId(itemlink);
				if (LootFilter.deleteItemFromInventory(itemlink, true, "")) then
					LootFilter.cleanList[z] = itemlink;
					z = z + 1;
				end;
			else
				slots = slots + 1;
			end;
		end;
	end;
	if (display) then
		table.sort(LootFilter.cleanList, LootFilter.sortByLink);
		if (table.getn(LootFilter.cleanList) > 0) then
			LootFilterButtonDeleteItems:Enable();
			LootFilter.CleanScrollBar_Update();
		else
			local cleanLine = getglobal("cleanLine1");
			cleanLine:SetText("No matching items were found.");
			cleanLine:Show();
		end;
	else
		if (slots < LootFilterVars[LootFilter.REALMPLAYER].freebagslots) and (table.getn(LootFilter.cleanList) > 0)  then
			local needSlots = LootFilterVars[LootFilter.REALMPLAYER].freebagslots-slots;
			if (needSlots > table.getn(LootFilter.cleanList)) then
				needSlots = table.getn(LootFilter.cleanList);
			end;
			table.sort(LootFilter.cleanList, LootFilter.sortByValue);
			for i=1,needSlots do
				LootFilter.deleteItemFromInventory(LootFilter.cleanList[i], false, "item has lowest value");
			end;
			LootFilter.cleanList = {};
		end;
	end;
end;

LootFilter.iWantTo = function()
	LootFilterButtonIWantTo:Enable();
end;


LootFilter.CleanScrollBar_Update = function ()
	local line; 
	local cleanLine;
	local lineplusoffset; 
	local numitems = table.getn(LootFilter.cleanList);
	if numitems < 20 then
		numitems = 20;
	end;
	FauxScrollFrame_Update(LootFilterScrollFrameClean,numitems,19,16);
	for line=1,19 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(LootFilterScrollFrameClean);
		cleanLine = getglobal("cleanLine"..line);
		if lineplusoffset <= table.getn(LootFilter.cleanList) then
			cleanLine:SetText(LootFilter.cleanList[lineplusoffset]);
			cleanLine:Show();
		else
			cleanLine:Hide();
		end
	end
end;

LootFilter.deleteItems = function (timeout, delete)
	LootFilterButtonDeleteItems:Enable();
	LootFilterButtonIWantTo:Disable();

	if (not delete) and (LootFilterButtonDeleteItems:GetText() ~= "Sell items") then
		LootFilter.initClean();
		local cleanLine = getglobal("cleanLine1");
		cleanLine:SetText("Vendor window closed while selling items.");
		cleanLine:Show();
		LootFilter.schedule(2, LootFilter.scanBags, true);
		return;
	end;

	if (timeout < time()) then
		LootFilter.initClean();
		local cleanLine = getglobal("cleanLine1");
		cleanLine:SetText("Timeout. One or more items in the list were not found.");
		cleanLine:Show();
		LootFilter.schedule(2, LootFilter.scanBags, true);
		return;
	end;
	if (table.getn(LootFilter.cleanList) >= 1) then
		LootFilter.deleteItemFromInventory(LootFilter.cleanList[1], false, "cleaning");
		table.remove(LootFilter.cleanList, 1);
		LootFilter.CleanScrollBar_Update(true);
		LootFilter.schedule(1, LootFilter.deleteItems, time()+LootFilter.LOOT_TIMEOUT);
	else
		LootFilter.scanBags(true);
	end;
end;

LootFilter.setItemRef = function (value)
	if (value ~= "") then
		SetItemRef(value);
	end;
end;
